package edu.uiuc.ncsa.cet.bean;

import java.io.Serializable;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import edu.uiuc.ncsa.cet.bean.dse.PublishedWorkflowBean;

public class CronJobBean extends CETBean implements Serializable, CETBean.TitledBean {

    /**
     * 
     */
    private static final long     serialVersionUID  = 1L;

    /** Title of the cron job */
    private String                title             = "";                           //$NON-NLS-1$

    /** Launch interval of the job */
    private String                launchInterval    = "";

    private String                cronID            = "";

    private Date                  submitDate        = null;

    private PublishedWorkflowBean publishedWorkflow = null;

    private Set<String>           executionIds      = new HashSet<String>();

    private Map<String, String>   parameters        = new HashMap<String, String>();

    private Map<String, String>   inputs            = new HashMap<String, String>();

    public String getTitle() {
        // TODO Auto-generated method stub
        return title;
    }

    public void setTitle(String title) {
        // TODO Auto-generated method stub
        this.title = title;
    }

    public void setLaunchInterval(String interval) {
        this.launchInterval = interval;
    }

    public String getLaunchInterval() {
        return launchInterval;
    }

    public Set<String> getWorkflowExecutionsURI() {
        return executionIds;
    }

    public Map<String, String> getParamMap() {
        return this.parameters;
    }

    public Map<String, String> getInputMap() {
        return this.inputs;
    }

    public void setParamMap(Map<String, String> params) {
        this.parameters = params;
    }

    public void setInputMap(Map<String, String> inputs) {
        this.inputs = inputs;
    }

    public void addWorkflowExecutionsURI(String uri) {
        this.executionIds.add(uri);
    }

    public void setPublishedWorkflow(PublishedWorkflowBean pwbu) {
        this.publishedWorkflow = pwbu;
    }

    public PublishedWorkflowBean getPublishedWorkflow() {
        return this.publishedWorkflow;
    }

    public void setWorkflowExecutionsURI(Set<String> uris) {
        this.executionIds = uris;
    }

    public void setDate(Date d) {
        this.submitDate = d;
    }

    public Date getDate() {
        return this.submitDate;
    }

    public void setCronID(String id) {
        this.cronID = id;
    }

    public String getCronID() {
        return cronID;
    }
}
