/**
 * 
 */
package edu.uiuc.ncsa.cet.bean.paw;

import edu.uiuc.ncsa.cet.bean.CETBean;

/**
 * A marked input, output or parameter exposed on the web.
 * 
 * @author Luigi Marini <lmarini@ncsa.illinois.edu>
 * 
 */
@SuppressWarnings("serial")
public class MarkedParameter extends CETBean {

    public enum TYPE {
        INPUT, PARAMETER, OUTPUT
    }

    /** Id of original parameter in workflow description **/
    private String refId;

    /** Parameter type **/
    private TYPE   type;

    public MarkedParameter() {
    }

    public MarkedParameter(String refId, TYPE type) {
        this.refId = refId;
        this.type = type;
    }

    public String getRefId() {
        return refId;
    }

    public void setRefId(String refId) {
        this.refId = refId;
    }

    public String getType() {
        return type.toString();
    }

    public void setType(String type) {
        this.type = TYPE.valueOf(type);
    }

}
