/**
 * 
 */
package edu.uiuc.ncsa.cet.bean.paw;

import java.util.List;
import java.util.Map;

import edu.uiuc.ncsa.cet.bean.CETBean;
import edu.uiuc.ncsa.cet.bean.DatasetBean;

/**
 * Configuration of a visualization of data outputted by a workflow using
 * specific web viewers.
 * 
 * @author Luigi Marini <lmarini@ncsa.illinois.edu>
 * 
 */
@SuppressWarnings("serial")
public class VisualizationConfiguration extends CETBean {

    /** Pretty name **/
    private String                       title;

    /** Long description **/
    private String                       description;

    /** Id of widget to instantiate in web UI **/
    private String                       widgetId;

    /** Datasets to visualize **/
    private List<DatasetBean>            datasets;

    /**
     * Map from visualization widget parameter to workflow parameter used to
     * configure visualization widget
     **/
    private Map<String, MarkedParameter> parametersMap;

    public VisualizationConfiguration() {
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getWidgetId() {
        return widgetId;
    }

    public void setWidgetId(String widgetId) {
        this.widgetId = widgetId;
    }

    public List<DatasetBean> getDatasets() {
        return datasets;
    }

    public void setDatasets(List<DatasetBean> dataSets) {
        this.datasets = dataSets;
    }

    public Map<String, MarkedParameter> getParametersMap() {
        return parametersMap;
    }

    public void setParametersMap(Map<String, MarkedParameter> parameters) {
        this.parametersMap = parameters;
    }
}
